#ifndef CCONNECTIONPOINT_H
#define CCONNECTIONPOINT_H

class DECLSPEC_NOVTABLE CConnectionPoint : public IConnectionPoint
{
public:
    inline IUnknown* GetUnknown() { return(static_cast<IConnectionPoint*>(this)); }

    // IUnknown
    IFACEMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef) ();
    IFACEMETHOD_(ULONG, Release)();

    // IConnectionPoint
    IFACEMETHOD(GetConnectionPointContainer)(IConnectionPointContainer** ppCPC);
    IFACEMETHOD(Advise)(IUnknown* pUnkSink, DWORD* pdwCookie);
    IFACEMETHOD(Unadvise)(DWORD dwCookie);
    IFACEMETHOD(EnumConnections)(IEnumConnections** ppEnum);

    __checkReturn HRESULT GetConnectData(__in UINT_PTR uIndex, __out CONNECTDATA* pData);
    FORCEINLINE void SetContainer(IConnectionPointContainer* pCPC) { m_pCPC = pCPC; }

    CConnectionPoint() : m_pCPC(nullptr) {}
    virtual ~CConnectionPoint();

protected:
    CList<CONNECTDATA> m_Connections;
    static __checkReturn HRESULT TryConnect(__in IUnknown* pUnk, __in REFIID riid, __deref_out void** ppvObject);
    IConnectionPointContainer* m_pCPC;

private:
    CConnectionPoint(const CConnectionPoint& other);
    CConnectionPoint& operator=(const CConnectionPoint& other);
};

#endif
