#ifndef CDEVICELIST_H
#define CDEVICELIST_H

class CDeviceList
{
public:
    static HRESULT DoModal(HWND hWndParent);

    void AddDevice(ISmartICE04* pDevice);
    void RemoveDevice(ISmartICE04* pDevice);
    void SetTargetVoltage(ISmartICE04* pDevice, LPCTSTR pszVoltage);
    void SetTarget(ISmartICE04* pDevice, LPCTSTR pszTarget);
    void SetDebugMode(ISmartICE04* pDevice, LPCTSTR pszDebugMode);

private:
    CDeviceList();

    CDeviceList(const CDeviceList& other);
    CDeviceList& operator=(const CDeviceList& other);

    struct ICONINDEX
    {
        long    id;
        int     idx;

        bool operator==(int rhs) const { return(rhs == this->id); }
    };

    int AddIcon(ISmartICE04* pDevice);
    int FindDevice(ISmartICE04* pDevice) const;
    void SetSubItemText(ISmartICE04* pDevice, int iSubItem, LPCTSTR psz);

    INT_PTR OnWmInitDialog(HWND hWnd, WPARAM wParam, LPARAM lParam);
    INT_PTR OnWmSize(HWND hWnd, WPARAM wParam, LPARAM lParam);
    INT_PTR OnWmCommand(HWND hWnd, WPARAM wParam, LPARAM lParam);
    INT_PTR OnWmNotify(HWND hWnd, WPARAM wParam, LPARAM lParam);
    INT_PTR OnWmDpiChanged(HWND hWnd, WPARAM wParam, LPARAM lParam);

    static INT_PTR CALLBACK DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

    CList<ICONINDEX> m_IconIndex;
    HWND m_hWnd;
    CSmartICE04DevicesEventsSinkT<CDeviceList> m_Sink;
    UINT    m_dpiX;
    UINT    m_dpiY;
};

#endif
