#ifndef CENUMCONNECTIONPOINT_H
#define CENUMCONNECTIONPOINT_H

class CEnumConnectionPoints : public IEnumConnectionPoints
{
public:
    //IUnknown
    IFACEMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef) ();
    IFACEMETHOD_(ULONG, Release)();

    IFACEMETHOD(Next)(ULONG cConnections, LPCONNECTIONPOINT* ppCP, ULONG* pcFetched);
    IFACEMETHOD(Skip)(ULONG cConnections);
    IFACEMETHOD(Reset)();
    IFACEMETHOD(Clone)(IEnumConnectionPoints** ppEnum);

    __checkReturn HRESULT Add(__in IUnknown* pCPt);

    CEnumConnectionPoints();

private:
    virtual ~CEnumConnectionPoints();
    CEnumConnectionPoints(const CEnumConnectionPoints& other);
    CEnumConnectionPoints& operator=(const CEnumConnectionPoints& other);

    CList<IConnectionPoint*>    m_list;
    volatile ULONG              m_lCursor;
    volatile ULONG              m_lRefCount;
};

#endif
