#include "precomp.h"

IFACEMETHODIMP
CSmartICE04DevicesEvents::GetConnectionInterface(IID* pIID)
{
    if(IsBadWritePtrT(pIID))
        return(E_POINTER);

    *pIID = IID_ISmartICE04DevicesEvents;
    return(S_OK);
}

void
CSmartICE04DevicesEvents::FireEvent(DISPID dispidEvt, IDispatch* TAG)
{
    IDispatch* pSender = nullptr;
    m_pCPC->QueryInterface(IID_IDispatch, reinterpret_cast<void**>(&pSender));

    m_Connections.Enum([dispidEvt, pSender, TAG](const CONNECTDATA& cd) -> bool
    {
        switch(dispidEvt)
        {
            case DISPID_SMARTICE04_ONDEVICEATTACHED:
                static_cast<ISmartICE04DevicesEvents*>(cd.pUnk)->OnDeviceAttached(pSender, TAG);
                break;
            case DISPID_SMARTICE04_ONDEVICEDETACHED:
                static_cast<ISmartICE04DevicesEvents*>(cd.pUnk)->OnDeviceDetached(pSender, TAG);
                break;
            default:
                break;
        }
        return(true);
#pragma warning(suppress: 4820)
    });
    
    if(pSender)
        pSender->Release();
}
