#include "precomp.h"

IFACEMETHODIMP
CSmartICE04Events::GetConnectionInterface(IID* pIID)
{
    if(IsBadWritePtrT(pIID))
        return(E_POINTER);

    *pIID = IID_ISmartICE04Events;
    return(S_OK);
}

void
CSmartICE04Events::FireEvent(DISPID dispidEvt, const VARIANT* param) const
{
    IDispatch* pSender = nullptr;
    m_pCPC->QueryInterface(IID_IDispatch, reinterpret_cast<void**>(&pSender));

    m_Connections.Enum([dispidEvt, pSender, param](const CONNECTDATA& cd) -> bool
    {
        switch(dispidEvt)
        {
            case DISPID_SMARTICE04_ONTARGETVOLTAGECHANGED:
                static_cast<ISmartICE04Events*>(cd.pUnk)->OnTargetVoltageChanged(pSender, V_BOOL(param));
                break;
            case DISPID_SMARTICE04_ONTARGETCHANGED:
                static_cast<ISmartICE04Events*>(cd.pUnk)->OnTargetChanged(pSender, static_cast<ChipId>(V_I2(param)));
                break;
            case DISPID_SMARTICE04_ONDEBUGMODECHANGED:
                static_cast<ISmartICE04Events*>(cd.pUnk)->OnDebugModeChanged(pSender, V_BOOL(param));
                break;
            default:
                break;
        }
        return(true);
#pragma warning(suppress: 4820)
    });
    
    if(pSender)
        pSender->Release();
}
