#ifndef CSMARTICE04PROGRESSDIALOG_H
#define CSMARTICE04PROGRESSDIALOG_H

class CSmartICE04ProgressDialog : public ISmartICE04ProgressDialog, public IProvideClassInfo, public ISupportErrorInfo
{
protected:
    inline IUnknown* GetUnknown() { return(static_cast<ISmartICE04ProgressDialog*>(this));   }
    inline HRESULT RaiseCOMException(DISPID dispid, HRESULT hr) { return(::RaiseCOMException(this, dispid, hr));  }

public:
    // IUnknown
    IFACEMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef) ();
    IFACEMETHOD_(ULONG, Release)();

    // IDispatch
    IFACEMETHOD(GetTypeInfoCount)(UINT* pctinfo);
    IFACEMETHOD(GetTypeInfo)(UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo);
    IFACEMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId);
    IFACEMETHOD(Invoke)(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr);

    // ISmartICE04ProgressDialog
    IFACEMETHOD(get_Title)(BSTR* Title);
    IFACEMETHOD(put_Title)(BSTR Title);
    IFACEMETHOD(get_Line1)(BSTR* line);
    IFACEMETHOD(put_Line1)(BSTR line);
    IFACEMETHOD(get_Line2)(BSTR* line);
    IFACEMETHOD(put_Line2)(BSTR line);
    IFACEMETHOD(get_LocaleID)(LCID* lcid);
    IFACEMETHOD(put_LocaleID)(LCID lcid);
    IFACEMETHOD(Create)(OAHWND hWndParent, IDispatch** ppProgress);

    // IProvideClassInfo
    IFACEMETHOD(GetClassInfo)(ITypeInfo** ppTI);

    // ISupportErrorInfo
    IFACEMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

    explicit CSmartICE04ProgressDialog(HRESULT* phr);

private:
    virtual ~CSmartICE04ProgressDialog();
    static HRESULT ReplaceBSTR(BSTR* pbstrOld, BSTR bstrNew);
    static HRESULT CopyBSTR(BSTR* pbstrDest, BSTR bstrSrc);

    ITypeInfo*      m_pTypeInfo;
    ITypeLib*       m_pTlb;
    BSTR            m_bstrTitle;
    BSTR            m_bstrLine1;
    BSTR            m_bstrLine2;
    volatile ULONG  m_lRefCount;
    LCID            m_lcid;
};

#endif
