#include "precomp.h"

CSmartICE04ProgressDummy::CSmartICE04ProgressDummy()
{
    m_pDispatch = this;
}

CSmartICE04ProgressDummy::~CSmartICE04ProgressDummy()
{
    m_pDispatch->Release();
}

IFACEMETHODIMP
CSmartICE04ProgressDummy::QueryInterface(REFIID, void**)
{
    return(E_NOTIMPL);
}

IFACEMETHODIMP_(ULONG)
CSmartICE04ProgressDummy::AddRef()
{
    return(2);
}

IFACEMETHODIMP_(ULONG)
CSmartICE04ProgressDummy::Release()
{
    return(1);
}

IFACEMETHODIMP
CSmartICE04ProgressDummy::GetTypeInfoCount(UINT*)
{
    return(E_NOTIMPL);
}

IFACEMETHODIMP
CSmartICE04ProgressDummy::GetTypeInfo(UINT, LCID, ITypeInfo**)
{
    return(E_NOTIMPL);
}

IFACEMETHODIMP
CSmartICE04ProgressDummy::GetIDsOfNames(REFIID, LPOLESTR*, UINT, LCID, DISPID*)
{
    return(E_NOTIMPL);
}

IFACEMETHODIMP
CSmartICE04ProgressDummy::Invoke(DISPID, REFIID, LCID, WORD, DISPPARAMS*, VARIANT*, EXCEPINFO*, UINT*)
{
    return(E_NOTIMPL);
}

IFACEMETHODIMP
CSmartICE04ProgressDummy::Start()
{
    static WCHAR start[] = L"Start";
    return(InvokeMethod(start));
}

IFACEMETHODIMP
CSmartICE04ProgressDummy::Stop()
{
    static WCHAR stop[] = L"Stop";
    return(InvokeMethod(stop));
}

IFACEMETHODIMP
CSmartICE04ProgressDummy::SetProgress(long lCompleted, long lTotal)
{
    static WCHAR setprogress[] = L"SetProgress";
    VARIANT var[2];

    VariantInit(&var[0]);
    VariantInit(&var[1]);

    V_VT(&var[0]) = VT_I4;
    V_I4(&var[0]) = lTotal;
    V_VT(&var[1]) = VT_I4;
    V_I4(&var[1]) = lCompleted;

    return(InvokeMethod(setprogress, var, 2));
}

IFACEMETHODIMP
CSmartICE04ProgressDummy::get_Canceled(VARIANT_BOOL* pblCanceled)
{
    static WCHAR canceled[] = L"Canceled";
    return(GetProperty(canceled, pblCanceled));
}

VOID
CSmartICE04ProgressDummy::SetDispatch(IDispatch* pDispatch)
{
    m_pDispatch->Release();
    m_pDispatch = (pDispatch) ? pDispatch : this;
    m_pDispatch->AddRef();
}

HRESULT
CSmartICE04ProgressDummy::GetProperty(LPWSTR pwszName, VARIANT *rgvarg)
{
    DISPPARAMS  dispparams;
    HRESULT     hr;
    DISPID      dispid;

    VariantInit(rgvarg);

    if(SUCCEEDED(hr = m_pDispatch->GetIDsOfNames(IID_NULL, &pwszName, 1, CThreadLocale::getLCID(), &dispid)))
    {
        dispparams.rgvarg               = nullptr;
        dispparams.rgdispidNamedArgs    = nullptr;
        dispparams.cArgs                = 0;
        dispparams.cNamedArgs           = 0;
        hr = m_pDispatch->Invoke(dispid, IID_NULL, CThreadLocale::getLCID(), DISPATCH_PROPERTYGET, &dispparams, rgvarg, nullptr, nullptr);
    }

    return(hr);
}

HRESULT
CSmartICE04ProgressDummy::GetProperty(LPWSTR pwszName, VARIANT_BOOL *pval)
{
    HRESULT hr;
    VARIANT var;

    VariantInit(&var);

    if(FAILED(hr = GetProperty(pwszName, &var)))
        return(hr);

    if(SUCCEEDED(hr = VariantChangeTypeEx(&var, &var, CThreadLocale::getLCID(), 0, VT_BOOL)))
        *pval = V_BOOL(&var);

    VariantClear(&var);
    return(hr);
}

HRESULT
CSmartICE04ProgressDummy::InvokeMethod(LPWSTR pwszName, VARIANT *rgvarg /* = nullptr */, UINT cArgs /* = 1 */, VARIANT *pVarResult /* = nullptr */)
{
    DISPPARAMS  dispparams;
    HRESULT     hr;
    DISPID      dispid;

    if(SUCCEEDED(hr = m_pDispatch->GetIDsOfNames(IID_NULL, &pwszName, 1, CThreadLocale::getLCID(), &dispid)))
    {
        dispparams.rgvarg               = rgvarg;
        dispparams.rgdispidNamedArgs    = nullptr;
        dispparams.cArgs                = (rgvarg) ? cArgs : 0;
        dispparams.cNamedArgs           = 0;
        hr = m_pDispatch->Invoke(dispid, IID_NULL, CThreadLocale::getLCID(), DISPATCH_METHOD, &dispparams, pVarResult, nullptr, nullptr);
    }

    return(hr);
}
