#ifndef MISC_H
#define MISC_H

#pragma warning(push)
#pragma warning(disable: 4820)

template<typename T> struct DLG_MSGMAP
{
    UINT uMsg;
    INT_PTR (T::*pfn)(HWND hWnd, WPARAM wParam, LPARAM lParam);
};

#pragma warning(pop)

BOOL InstallDpiChangeMonitor(HWND hWndParent, UINT uMsg);
HRESULT HresultFromHidErrorCode(NTSTATUS status);
HRESULT HresultFromErrno();
BOOL RectScreenToClient(_In_ HWND hWnd, _Inout_ RECT* prc);
BOOL EnableDlgItem(HWND hDlg, int nIDDlgItem, BOOL blEnable);
int MinGetSystemMetricsForDpi(__in int nIndex1, __in int nIndex2, __in UINT dpi);
void ListView_ScaleColumnHeaders(HWND hWndLV, UINT dpiFrom, UINT dpiTo);
void TrimA(char* psz);
HRESULT GetTypeInfoOfChipIdEnumeration(ISmartICE04* pDevice, ITypeInfo** ppTypeInfo);
HRESULT MyTaskDialog(HWND hWndParent, HINSTANCE hInstance, PCWSTR pszWindowTitle, PCWSTR pszMainInstruction, PCWSTR pszContent, TASKDIALOG_COMMON_BUTTON_FLAGS dwCommonButtons, PCWSTR pszIcon, int *pnButton);
void TrimEx(PTSTR psz, LCID lcid);
HRESULT RedimAndLockArray(SAFEARRAY* psa, long lStartAddress, ULONG len);
UINT MyGetDpiForWindow(HWND hWnd);
int MyGetSystemMetricsForDpi(int nIndex, UINT dpi);
BOOL CenterWindow(HWND hWnd, HWND hWndParent);

#if defined(_MSC_VER) && (_MSC_VER < 1800)
FORCEINLINE double round(double val) { return(floor(val + 0.5)); }
#endif

FORCEINLINE LONG Scale(LONG val, UINT dpiFrom, UINT dpiTo) { return(static_cast<LONG>(round(static_cast<double>(val) * static_cast<double>(dpiTo)) / static_cast<double>(dpiFrom))); }

HRESULT BSTRFromStringA(const char* pstr, BSTR* pbstr);
FORCEINLINE HRESULT BSTRFromStringW(const wchar_t* pstr, BSTR* pbstr) { return((nullptr != (*pbstr = SysAllocString(pstr))) ? S_OK : E_OUTOFMEMORY); }

#ifdef UNICODE
#define BSTRFromString  BSTRFromStringW
#else
#define BSTRFromString  BSTRFRomStringA
#define Trim            TrimA
#endif

#ifdef _DEBUG
template<typename T> inline BOOL IsBadWritePtrT(T* pt) { return(::IsBadWritePtr(pt, sizeof(*pt))); }
template<typename T> inline BOOL IsBadReadPtrT(const T* pt) { return(::IsBadReadPtr(pt, sizeof(*pt))); }
#else
template<typename T> inline BOOL IsBadWritePtrT(T* pt) { return(!pt); }
template<typename T> inline BOOL IsBadReadPtrT(const T* pt) { return(!pt); }
#endif

// combaseapi.h defines STDMETHOD together with COM_DECLSPEC_NOTHROW,
// whereas STDMETHODIMP (winnt.h) got defined without it, hence you'll
// get a ton of C4986 when compiling with /Wall. The definitions below
// address this issue.
#undef STDMETHODIMP
#define STDMETHODIMP            COM_DECLSPEC_NOTHROW HRESULT STDMETHODCALLTYPE
#undef STDMETHODIMP_
#define STDMETHODIMP_(type)     COM_DECLSPEC_NOTHROW type STDMETHODCALLTYPE
#undef IFACEMETHODIMP
#define IFACEMETHODIMP          __override STDMETHODIMP
#undef IFACEMETHODIMP_
#define IFACEMETHODIMP_(type)   __override STDMETHODIMP_(type)

#endif
