#include "precomp.h"

INT_PTR
CSmartICE04Dialog::OnWmInitDialog(HWND hWnd, WPARAM, LPARAM)
{
    TCHAR sz[80];
    LoadString(g_hInst, IDS_CUEBANNER, sz, _countof(sz));
    SendDlgItemMessage(hWnd, IDC_DEBUGADAPTER, CB_SETCUEBANNER, 0, reinterpret_cast<LPARAM>(sz));
    InitializeDebugAdaptersCB(GetDlgItem(hWnd, IDC_DEBUGADAPTER));
    SendDlgItemMessage(hWnd, IDC_DEBUGADAPTER, CBEM_SETWINDOWTHEME, 0, reinterpret_cast<LPARAM>(L"Explorer"));
    EmbedControl(GetDlgItem(hWnd, IDC_IMAGE), GetDlgItem(hWnd, IDC_IMAGE_BROWSE));
    return TRUE;
}

VOID
CSmartICE04Dialog::DoDownload(HWND hWndParent)
{
    CSiUtil*    pSiUtil;
    CCursor     cursor(IDC_WAIT);
    char        szFileName[MAX_PATH * 2];
    int         idx;

    if(CB_ERR == (idx = static_cast<int>(SendDlgItemMessage(hWndParent, IDC_DEBUGADAPTER, CB_GETCURSEL, 0, 0))))
        return;

    const char* pSerNum = reinterpret_cast<const char*>(SendDlgItemMessage(hWndParent, IDC_DEBUGADAPTER, CB_GETITEMDATA, static_cast<WPARAM>(idx), 0));
    CSiUtilEC2 ec2(PtrToInt(pSerNum));
    CSiUtilEC3 ec3(pSerNum);

    if(IS_INTRESOURCE(pSerNum))
        pSiUtil = &ec2;
    else
        pSiUtil = &ec3;

    if(GetWindowTextA(hWndParent, szFileName, _countof(szFileName)))
        pSiUtil->SetAppName(szFileName);

    GetDlgItemTextA(hWndParent, IDC_IMAGE, szFileName, _countof(szFileName));

    if(FAILED(pSiUtil->Download(szFileName, TRUE)))
        return;

    cursor.Refresh();
    WriteSerialNumber(pSiUtil);
    cursor.Refresh();
    pSiUtil->SetTargetGo();
    SelectDebugAdapter(GetDlgItem(hWndParent, IDC_DEBUGADAPTER), *pSiUtil);
}

VOID
CSmartICE04Dialog::WriteSerialNumber(CSiUtil* pSiUtil)
{
    SYSTEMTIME st;
    FILETIME ft;
    WCHAR sz[32];

    GetLocalTime(&st);
    SystemTimeToFileTime(&st, &ft);
    StringCchPrintfW(sz, _countof(sz), L"%08X-%08X", ft.dwHighDateTime, ft.dwLowDateTime);
    pSiUtil->SetCodeMemory(reinterpret_cast<BYTE*>(sz), 0x3C02, static_cast<unsigned int>(wcslen(sz) * sizeof(sz[0])));
}

INT_PTR
CSmartICE04Dialog::OnWmCommand(HWND hWnd, WPARAM wParam, LPARAM)
{
    switch(LOWORD(wParam))
    {
        case IDC_BOOTLOADER_BROWSE:
        case IDC_IMAGE_BROWSE:
            AskForFileName(hWnd, LOWORD(wParam) - 1, IDS_FILTER, GUID_SmartICE04);
            return(TRUE);
        case IDOK:
            DoDownload(hWnd);
            return TRUE;
        case IDCANCEL:
            EndDialog(hWnd, 0);
            return TRUE;
        default:
            break;
    }

    return FALSE;
}

INT_PTR
CSmartICE04Dialog::OnWmDeviceChange(HWND hWnd, WPARAM, LPARAM)
{
    InitializeDebugAdaptersCB(GetDlgItem(hWnd, IDC_DEBUGADAPTER));
    return 0;
}

INT_PTR CALLBACK
CSmartICE04Dialog::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    static const DLG_MSGMAP<CSmartICE04Dialog> sc_map[] =
    {
        { WM_COMMAND,       &CSmartICE04Dialog::OnWmCommand         },
        { WM_DEVICECHANGE,  &CSmartICE04Dialog::OnWmDeviceChange    },
        { WM_DPICHANGED,    &CSmartICE04Dialog::OnWmDeviceChange    }
    };

    for(uintptr_t idx = 0; idx < _countof(sc_map); ++idx)
    {
        if(sc_map[idx].uMsg == uMsg)
        {
            CSmartICE04Dialog* pThis = reinterpret_cast<CSmartICE04Dialog*>(GetWindowLongPtr(hWnd, DWLP_USER));

            if(pThis)
                return (pThis->*sc_map[idx].pfn)(hWnd, wParam, lParam);
        }
    }

    if(uMsg == WM_INITDIALOG)
    {
        SetWindowLongPtr(hWnd, DWLP_USER, lParam);
        return(reinterpret_cast<CSmartICE04Dialog*>(lParam)->OnWmInitDialog(hWnd, wParam, lParam));
    }

    return FALSE;
}

int
CSmartICE04Dialog::DoModal(HWND hWndParent)
{
    CSmartICE04Dialog dlg;
    return(static_cast<int>(DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_SMARTICE04), hWndParent, DlgProc, reinterpret_cast<LPARAM>(&dlg))));
}
