#ifndef SIUTIL_H
#define SIUTIL_H

#define DLLIMPORT __declspec(dllimport)

#define TARGET_DISCONNECTED_FLAG 0x8000

#ifdef __cplusplus
extern "C" {
#endif

    DLLIMPORT HRESULT   __stdcall Connect(int nComPort, int nDisableDialogBoxes, int nECprotocol, int nBaudRateIndex);
    DLLIMPORT HRESULT   __stdcall Download(char* sDownloadFile, int nDeviceErase, int nDisableDialogBoxes, int nDownloadScratchPadSFLE, int nBankSelect, int nLockFlash, BOOL bPersistFlash);
    DLLIMPORT HRESULT   __stdcall DownloadCS(char* sDownloadFile, int nDeviceErase, int nDisableDialogBoxes, int nDownloadScratchPadSFLE, int nBankSelect, int nLockFlash, BOOL bPersistFlash, unsigned short* usChecksum);
    DLLIMPORT HRESULT   __stdcall DownloadTxt(char* sDownloadFile, DWORD wStartAddress, int nDeviceErase, int nDisableDialogBoxes, int nLockFlash, BOOL bPersistFlash, unsigned short* usChecksum);
    DLLIMPORT HRESULT   __stdcall Disconnect(int nComPort);
    DLLIMPORT HRESULT   __stdcall GetRAMMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength);
    DLLIMPORT HRESULT   __stdcall SetRAMMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength);
    DLLIMPORT HRESULT   __stdcall GetXRAMMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength);
    DLLIMPORT HRESULT   __stdcall SetXRAMMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength);
    DLLIMPORT HRESULT   __stdcall GetCodeMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength);
    DLLIMPORT HRESULT   __stdcall SetCodeMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength, BOOL bDisableDialogs);
    DLLIMPORT HRESULT   __stdcall GetScratchPadMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength);
    DLLIMPORT HRESULT   __stdcall SetScratchPadMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength, BOOL bDisableDialogs);
    DLLIMPORT BOOL      __stdcall Connected();
    DLLIMPORT HRESULT   __stdcall SetTargetGo();
    DLLIMPORT HRESULT   __stdcall SetTargetHalt();
    DLLIMPORT HRESULT   __stdcall TargetReset();
    DLLIMPORT HRESULT   __stdcall FLASHErase(int nComPort, int nDisableDialogBoxes, int nECprotocol);
    DLLIMPORT HRESULT   __stdcall SetJTAGDeviceAndConnect(int nComPort, int nDisableDialogBoxes, BYTE DevicesBeforeTarget, BYTE DevicesAfterTarget, WORD IRBitsBeforeTarget, WORD IRBitsAfterTarget);
    DLLIMPORT HRESULT   __stdcall ISupportBanking(int* nSupportedBanks);
    DLLIMPORT int       __stdcall GetSAFirmwareVersion();
    DLLIMPORT char*     __stdcall GetDLLVersion();
    DLLIMPORT HRESULT   __stdcall ConnectUSB(const char* sSerialNum, int nECprotocol, int nPowerTarget, int nDisableDialogBoxes);
    DLLIMPORT HRESULT   __stdcall DisconnectUSB();
    DLLIMPORT HRESULT   __stdcall FLASHEraseUSB(const char* sSerialNum, int nDisableDialogBoxes, int nECprotocol);
    DLLIMPORT HRESULT   __stdcall SetJTAGDeviceAndConnectUSB(const char* sSerialNum, int nPowerTarget, int nDisableDialogBoxes, BYTE DevicesBeforeTarget, BYTE DevicesAfterTarget, WORD IRBitsBeforeTarget, WORD IRBitsAfterTarget);
    DLLIMPORT HRESULT   __stdcall USBDebugDevices(DWORD* dwDevices);
    DLLIMPORT HRESULT   __stdcall GetUSBDeviceSN(DWORD dwDeviceNum, const char** psSerialNum);
    DLLIMPORT HRESULT   __stdcall GetUSBDLLVersion(const char** pVersionString);
    DLLIMPORT int       __stdcall GetUSBFirmwareVersion();
    DLLIMPORT HRESULT   __stdcall GetDeviceName(const char** psDeviceName);
    DLLIMPORT HRESULT   __stdcall GetDeviceRevision(BYTE* pPartRev);
    DLLIMPORT char*     __stdcall GetErrorMsg(HRESULT errorCode);
    DLLIMPORT HRESULT   __stdcall SetAppName(const char* AppName);
    DLLIMPORT HRESULT   __stdcall VerifyFlashDownload(char* sDownloadFile, int nDisableDialogBoxes, int nBankSelect);
    DLLIMPORT HRESULT   __stdcall VerifyFlashDownloadCS(char* sDownloadFile, int nDisableDialogBoxes, int nBankSelect, unsigned short* usChecksum);

#ifdef __cplusplus
}
#endif

#endif
